// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16AO4MF/16AO4MF_Linux_2.x.x.x_GSC_DN/driver/irq.c $
// $Rev: 43266 $
// $Date: 2018-07-09 17:21:40 -0500 (Mon, 09 Jul 2018) $

// 16AO4MF: Device Driver: source file

#include "main.h"



//*****************************************************************************
void dev_irq_isr_local_handler(dev_data_t* dev)
{
	static const u32	list[]	=
	{
		AO4MF_WAIT_GSC_INIT_DONE,
		AO4MF_WAIT_GSC_AUTO_CAL_DONE,
		AO4MF_WAIT_GSC_AO_BUF_EMPTY,
		AO4MF_WAIT_GSC_AO_BUF_1Q_FULL,
		AO4MF_WAIT_GSC_AO_BUF_3Q_FULL,
		AO4MF_WAIT_GSC_BURST_TRIG_READY,
		AO4MF_WAIT_GSC_LOAD_READY,
		AO4MF_WAIT_GSC_LOAD_READY_END
	};

	u32				bcr;
	chan_data_t*	chan;
	int				i;
	u32				irq;

	for (i = 0; i <= 3; i++)
	{
		chan	= &dev->channel[i];
		bcr		= os_reg_mem_rx_u32(NULL, chan->vaddr.gsc_bcr_32);

		if (bcr & D11)
		{
			// Clear the interrupt.
			bcr	&= ~D11;
			os_reg_mem_tx_u32(NULL, chan->vaddr.gsc_bcr_32, bcr);

			// Resume any thread waiting on this interrupt.
			irq	= (bcr & (D8 | D9 | D10)) >> 8;
			gsc_wait_resume_irq_gsc(chan, list[irq]);
		}
	}
}



//*****************************************************************************
void irq_reg_mod(chan_data_t* chan, VADDR_T va, u32 value, u32 mask)
{
	os_reg_mem_mx_u32(chan->dev, va, value, mask);
}



//*****************************************************************************
int dev_irq_create(dev_data_t* dev)
{
	int	i;
	int	ret;

	for (i = 0; i < 4; i++)
		os_reg_mem_tx_u32(dev, dev->channel[i].vaddr.gsc_bcr_32, 0);

	ret	= gsc_irq_create(dev);
	return(ret);
}



//*****************************************************************************
void dev_irq_destroy(dev_data_t* dev)
{
	int	i;

	for (i = 0; i < 4; i++)
		os_reg_mem_tx_u32(dev, dev->channel[i].vaddr.gsc_bcr_32, 0);

	gsc_irq_destroy(dev);
}


