// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16AO4MF/16AO4MF_Linux_2.x.x.x_GSC_DN/driver/reg.c $
// $Rev: 52837 $
// $Date: 2023-04-11 12:37:25 -0500 (Tue, 11 Apr 2023) $

// 16AO4MF: Device Driver: source file

#include "main.h"



//*****************************************************************************
int dev_reg_mod_alt(chan_data_t* chan, gsc_reg_t* arg)
{
	u16			offset;
	int			ret;
	u16			size;
	gsc_reg_t	tmp;
	u16			type;

	type		= GSC_REG_TYPE_BAR2;
	size		= GSC_REG_SIZE(arg->reg);
	offset		= GSC_REG_OFFSET(arg->reg);
	offset		+= chan->index * 0x40;		// Adjust for channel index.
	tmp.reg		= GSC_REG_ENCODE(type, size, offset);
	tmp.value	= arg->value;
	tmp.mask	= arg->mask;
	ret			= gsc_reg_mod_ioctl(chan, &tmp);
	return(ret);
}



//*****************************************************************************
int dev_reg_read_alt(chan_data_t* chan, gsc_reg_t* arg)
{
	u16			offset;
	int			ret;
	u16			size;
	gsc_reg_t	tmp;
	u16			type;

	type		= GSC_REG_TYPE_BAR2;
	size		= GSC_REG_SIZE(arg->reg);
	offset		= GSC_REG_OFFSET(arg->reg);
	offset		+= chan->index * 0x40;		// Adjust for channel index.
	tmp.reg		= GSC_REG_ENCODE(type, size, offset);
	tmp.value	= arg->value;
	tmp.mask	= arg->mask;
	ret			= gsc_reg_read_ioctl(chan, &tmp);
	arg->value	= tmp.value;
	return(ret);
}



//*****************************************************************************
int dev_reg_write_alt(chan_data_t* chan, gsc_reg_t* arg)
{
	u16			offset;
	int			ret;
	u16			size;
	gsc_reg_t	tmp;
	u16			type;

	type		= GSC_REG_TYPE_BAR2;
	size		= GSC_REG_SIZE(arg->reg);
	offset		= GSC_REG_OFFSET(arg->reg);
	offset		+= chan->index * 0x40;		// Adjust for channel index.
	tmp.reg		= GSC_REG_ENCODE(type, size, offset);
	tmp.value	= arg->value;
	tmp.mask	= arg->mask;
	ret			= gsc_reg_write_ioctl(chan, &tmp);
	return(ret);
}


