// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16AO4MF/16AO4MF_Linux_2.x.x.x_GSC_DN/include/16ao4mf_utils.h $
// $Rev: 52820 $
// $Date: 2023-04-11 12:19:43 -0500 (Tue, 11 Apr 2023) $

// 16AO4MF: Utilities: header file

#ifndef	__16AO4MF_UTILS_H__
#define	__16AO4MF_UTILS_H__

#include "16ao4mf_api.h"
#include "gsc_utils.h"
#include "gsc_utils_pci.h"



// prototypes *****************************************************************

// API utility services

int	ao4mf_close_util			(int fd, int index, int verbose);
int ao4mf_init_util				(int verbose);
int ao4mf_ioctl_util			(int fd, int index, int verbose, int request, void* arg);
int	ao4mf_open_util				(int device, int share, int index, int verbose, int* fd);
int ao4mf_read_util				(int fd, int index, int verbose, void* dst, size_t bytes);
int	ao4mf_write_util			(int fd, int index, int verbose, const void* src, size_t bytes);

// IOCTL utility services

int	ao4mf_ao_buf_clear			(int fd, int index, int verbose);								// AO4MF_IOCTL_AO_BUF_CLEAR
int	ao4mf_ao_buf_load_ready		(int fd, int index, int verbose, s32* get);						// AO4MF_IOCTL_AO_BUF_LOAD_READY
int	ao4mf_ao_buf_load_req		(int fd, int index, int verbose);								// AO4MF_IOCTL_AO_BUF_LOAD_REQ
int	ao4mf_ao_buf_mode			(int fd, int index, int verbose, s32 set, s32* get);			// AO4MF_IOCTL_AO_BUF_MODE
int	ao4mf_ao_buf_size			(int fd, int index, int verbose, s32 set, s32* get);			// AO4MF_IOCTL_AO_BUF_SIZE
int	ao4mf_ao_buf_status			(int fd, int index, int verbose, s32* get);						// AO4MF_IOCTL_AO_BUF_STATUS
int	ao4mf_ao_clk_enable			(int fd, int index, int verbose, s32 set, s32* get);			// AO4MF_IOCTL_AO_CLK_ENABLE
int	ao4mf_ao_clk_src			(int fd, int index, int verbose, s32 set, s32* get);			// AO4MF_IOCTL_AO_CLK_SRC
int	ao4mf_ao_ext_clking_ready	(int fd, int index, int verbose, s32* get);						// AO4MF_IOCTL_AO_EXT_CLKING_READY
int	ao4mf_ao_sw_clk				(int fd, int index, int verbose);								// AO4MF_IOCTL_AO_SW_CLK
int	ao4mf_auto_cal				(int fd, int index, int verbose);								// AO4MF_IOCTL_AUTO_CAL
int	ao4mf_auto_cal_sts			(int fd, int index, int verbose, s32* get);						// AO4MF_IOCTL_AUTO_CAL_STS
int	ao4mf_burst_mode			(int fd, int index, int verbose, s32 set, s32* get);			// AO4MF_IOCTL_BURST_MODE
int	ao4mf_burst_ready			(int fd, int index, int verbose, s32* get);						// AO4MF_IOCTL_BURST_READY
int	ao4mf_burst_trigger			(int fd, int index, int verbose);								// AO4MF_IOCTL_BURST_TRIGGER
int	ao4mf_data_format			(int fd, int index, int verbose, s32 set, s32* get);			// AO4MF_IOCTL_DATA_FORMAT
int	ao4mf_dio_dir				(int fd, int index, int verbose, s32 set, s32* get);			// AO4MF_IOCTL_DIO_DIR
int	ao4mf_dio_rx				(int fd, int index, int verbose, s32* get);						// AO4MF_IOCTL_DIO_RX
int	ao4mf_dio_tx				(int fd, int index, int verbose, s32 set, s32* get);			// AO4MF_IOCTL_DIO_TX
int	ao4mf_fref_clk_src			(int fd, int index, int verbose, s32 set, s32* get);			// AO4MF_IOCTL_FREF_CLK_SRC
int	ao4mf_initialize			(int fd, int index, int verbose);								// AO4MF_IOCTL_INITIALIZE
int	ao4mf_int_samp_rate			(int fd, int index, int verbose, s32 set, s32* get);			// AO4MF_IOCTL_INT_SAMP_RATE
int	ao4mf_irq_sel				(int fd, int index, int verbose, s32 set, s32* get);			// AO4MF_IOCTL_IRQ_SEL
int	ao4mf_nclk					(int fd, int index, int verbose, s32 set, s32* get);			// AO4MF_IOCTL_NCLK
int	ao4mf_nrate					(int fd, int index, int verbose, s32 set, s32* get);			// AO4MF_IOCTL_NRATE
int	ao4mf_query					(int fd, int index, int verbose, s32 set, s32* get);			// AO4MF_IOCTL_QUERY
int	ao4mf_rate_gen_sel			(int fd, int index, int verbose, s32 set, s32* get);			// AO4MF_IOCTL_RATE_GEN_SEL
int	ao4mf_reg_mod				(int fd, int index, int verbose, u32 reg, u32 set, u32 mask);	// AO4MF_IOCTL_REG_MOD
int	ao4mf_reg_read				(int fd, int index, int verbose, u32 reg, u32* get);			// AO4MF_IOCTL_REG_READ
int	ao4mf_reg_write				(int fd, int index, int verbose, u32 reg, u32 set);				// AO4MF_IOCTL_REG_WRITE
int	ao4mf_tx_io_abort			(int fd, int index, int verbose, s32* get);						// AO4MF_IOCTL_TX_IO_ABORT
int	ao4mf_tx_io_mode			(int fd, int index, int verbose, s32 set, s32* get);			// AO4MF_IOCTL_TX_IO_MODE
int	ao4mf_tx_io_timeout			(int fd, int index, int verbose, s32 set, s32* get);			// AO4MF_IOCTL_TX_IO_TIMEOUT
int	ao4mf_wait_cancel			(int fd, int index, int verbose, gsc_wait_t* wait);				// AO4MF_IOCTL_WAIT_CANCEL
int	ao4mf_wait_event			(int fd, int index, int verbose, gsc_wait_t* wait);				// AO4MF_IOCTL_WAIT_EVENT
int	ao4mf_wait_status			(int fd, int index, int verbose, gsc_wait_t* wait);				// AO4MF_IOCTL_WAIT_STATUS
int	ao4mf_xcvr_in				(int fd, int index, int verbose, s32 set, s32* get);			// AO4MF_IOCTL_XCVR_IN

// Auxiliary utility services

int	ao4mf_config_ao				(int fd, int index, int verbose, s32 fsamp);
int	ao4mf_fsamp_compute			(int fd, int index, int verbose, s32 fsamp, s32* irate, s32* nrate, s32* fref_src, s32* nclk, double* rate);
int	ao4mf_fsamp_report			(int fd, int index, int verbose, int chan, s32* fsamp);
int	ao4mf_fsamp_report_all		(int fd, int index, int verbose, s32* fsamp);
int	ao4mf_id_device				(int fd, int index, int verbose);

int	ao4mf_count_boards			(int verbose, s32* get);
int	ao4mf_reg_list				(int fd, int detail);

const gsc_reg_def_t*	ao4mf_reg_get_def_id	(int reg);
const gsc_reg_def_t*	ao4mf_reg_get_def_index	(int index);
const char*				ao4mf_reg_get_desc		(int reg);
const char*				ao4mf_reg_get_name		(int reg);



#endif
